using System;
using System.Text.Json.Serialization;
namespace concerto {
   abstract class Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "concerto.Concept";
   }
   abstract class Asset : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "concerto.Asset";
      [JsonPropertyName("$identifier")]
      public string _identifier { get; set; }
   }
   abstract class Participant : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "concerto.Participant";
      [JsonPropertyName("$identifier")]
      public string _identifier { get; set; }
   }
   abstract class Transaction : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "concerto.Transaction";
      [JsonPropertyName("$timestamp")]
      public DateTime _timestamp { get; set; }
   }
   abstract class Event : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "concerto.Event";
      [JsonPropertyName("$timestamp")]
      public DateTime _timestamp { get; set; }
   }
}
